(****************************************************************************)
(**** Unit Clipbrd **********************************************************)
(********************************************************* Version 0.0.3 ****)
(****************************************************************************)
(** (C) Copyright Eric Sigoillot, 2004       (Creation, Maintenance, MAJ)  **)
(**     E-Mail    hdd34@redaction-developpez.com                           **)
(************************************************************** 666 lignes **)
(**                                                                        **)
(**  Caracteristiques :                                                   **)
(**                                                  **)
(**    * Gestion d'un presse-papiers                                       **)
(**    * Utilise par defaut le presse-papiers de Windows                   **)
(**    * Compatible Windows NT (NT4, 2000, XP)                             **)
(**                                                                        **)
(**  Avertissements relatifs a certaines fonctionnalites :                **)
(**               **)
(**    ! Si cette unite est utilisee sous environnement NT et              **)
(**      conjointement avec le presse-papiers Windows, alors il est        **)
(**      necessaire d'avoir recours au VDD externe (NTDOSMGR.DLL)          **)
(**                                                                        **)
(**    ! Il est inutile de creer soi-meme un objet TClipboard. Il suffit   **)
(**      de se servir de la fonction Clipboard qui renvoie un pointeur     **)
(**      directement accessible                                            **)
(**                                                                        **)
(**  Limitations, problemes connus :                                      **)
(**                                     **)
(**    ! Non compatible avec le mode protege DPMI Borland ou autre         **)
(**    ! Il est impossible d'utiliser des donnees de plus de 64 Ko avec    **)
(**      le presse-papiers Windows                                         **)
(**                                                                        **)
(**  Configuration minimale necessaire :                                  **)
(**                                 **)
(**    * Processeur 80386 SX avec coprocesseur 80387                       **)
(**    * Windows 3.1 ou superieur pour utiliser son presse-papiers         **)
(**    * Turbo Pascal 7.0+ ou Borland Pascal 7.0+ (Target... Real)         **)
(**    * Package objet de Turbo Pascal (contenant les unites Objects,      **)
(**      Strings et Memory)                                                **)
(**    * VDD NTDOSMGR.DLL pour une utilisation sous environnement NT       **)
(*     * Unite NTVDM                                                       **)
(**                                                                        **)
(**  Informations de copyright :                                          **)
(**                                         **)
(**    > Cette unite peut etre utilisee librement sans consentement        **)
(**      prealable de l'auteur pour un usage NON COMMERCIAL EXCLUSIVEMENT  **)
(**      La presence du nom de l'auteur dans le logiciel final n'est pas   **)
(**      obligatoire, mais appreciee                                       **)
(**    > En cas de distribution d'un programme (freeware uniquement !)     **)
(**      utilisant cette unite, une copie du logiciel ou bien une adresse  **)
(**      Internet permettant de le recuperer seraient les bienvenues       **)
(**    > L'auteur ne peut EN AUCUN CAS etre tenu responsable d'une         **)
(**      quelconque perte materielle ou logicielle, ou d'un quelconque     **)
(**      prejudice subit par l'utilisateur                                 **)
(**    > Cette unite est toujours en developpement : cela inclut des       **)
(**      risques non negligeables d'erreurs ou d'incompatibilites          **)
(**      Neanmoins, tout est fait pour eviter un quelconque desagrement    **)
(**      Si cette unite se revelait incompatible avec une configuration    **)
(**      quelconque, la responsabilite de l'auteur ne saurait etre engagee **)
(**    > L'utilisation de cette unite se fait AUX RISQUES ET PERILS de     **)
(**      l'utilisateur                                                     **)
(**    > En cas de problemes, il est conseille de les signaler a l'auteur  **)
(**      pour une correction eventuelle en vue d'eviter un desagrement a   **)
(**      un autre utilisateur                                              **)
(**                                                                        **)
(**    > Les retours de la part des utilisateurs de l'unite sont toujours  **)
(**      apprecies. N'hesitez pas a faire part de vos remarques a l'auteur **)
(**                                                                        **)
(**                                                                        **)
(**     D'apres :                                                         **)
(**       * "Ralph Brown's Interrupts List"                                **)
(**         Ralph Brown                                                    **)
(**         29 Decembre 2002                                               **)
(**         http://www-2.cs.cmu.edu/afs/cs/user/ralf/pub/WWW/files.html    **)
(**                                                                        **)
(**       * "Microsoft Windows 2000 DDK"                                   **)
(**         Microsoft                                                      **)
(**         Juillet 2000                                                   **)
(**         http://www.microsoft.com/ddk/                                  **)
(**                                                                        **)
(**     Turbo Pascal et Borland Pascal sont des noms deposes de Borland   **)
(**     Windows est un nom depose de Microsoft Corporation                **)
(****************************************************************************)
unit Clipbrd;

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}

{$DEFINE AllowNT}
{$DEFINE AllowVBE2}

interface

uses
  Objects {$IFDEF AllowVBE2}, Vbe2, Vbe2Ext{$ENDIF};

{ Formats acceptes par le presse-papiers }
const
  CF_TEXT         = 1;
  CF_BITMAP       = 2;
  CF_METAFILEPICT = 3;
  CF_SYLK         = 4;
  CF_DIF          = 5;
  CF_TIFF         = 6;
  CF_OEMTEXT      = 7;
  CF_DIB          = 8;
  CF_PALETTE      = 9;
  CF_PENDATA      = 10;
  CF_RIFF         = 11;
  CF_WAVE         = 12;

const
  CLargeBlockSize = 32768;


type
  PClipboard = ^TClipboard;
  TClipboard = object(TObject)
  private
    FOpenCount: Word;
    function IsAvailable: Boolean;
  public
    constructor Init;
    destructor Done; virtual;
    function  GetVersion: Word;
    procedure Open; virtual;
    procedure Close; virtual;
    procedure Clear; virtual;
    procedure SetData(AFormat: Word; var ABuffer; ASize: Longint); virtual;
    function  GetDataSize(AFormat: Word): Longint; virtual;
    procedure GetData(AFormat: Word; var ABuffer); virtual;
    procedure SetLargeData(AFormat: Word; AXMSOfs: Longint; ASize: Longint);
    procedure GetLargeData(AFormat: Word; AXMSOfs: Longint);
    procedure SetAsText(const AText: string);
    function  GetAsText: string;
    {$IFDEF AllowVBE2}
    procedure SetBitmap(ABmp: PBitmap);
    procedure GetBitmap(ABmp: PBitmap);
    {$ENDIF}
  end;


{ Fonction generale d'interfacage avec le presse-papiers }
function Clipboard: PClipboard;


{$IFDEF AllowNT}
{$IFDEF AllowVBE2}
procedure ScreenCopy;
{$ENDIF}
{$ENDIF}

implementation

uses
  Dos, XMS {$IFDEF AllowNT}, NTVDM{$ENDIF};

var
  MainClip: PClipboard;

{$IFDEF AllowNT}
const
  CVDDModule = 'NTDOSMGR.DLL';
  CVDDInit   = 'VDDInit';
  CVDDCall   = 'VDDCall';

var
  VDD: Word;
  SavedInt2F: procedure;

procedure InstallNTClipboard; forward;
procedure UninstallNTClipboard; forward;

{$ENDIF}


var
  SavedExitProc: Pointer;

procedure ClipbrdExitProc; far;
begin
  ExitProc := SavedExitProc;
  if Assigned(MainClip) then
  begin
    MainClip^.Free;
    MainClip := nil;
  end;

  {$IFDEF AllowNT}
  if VDD <> 0 then UninstallNTClipboard;
  {$ENDIF}
end;

{$IFDEF AllowNT}

{$F+}
procedure Int2FHandler(_Flags, _CS, _IP, _AX, _BX, _CX, _DX, _SI, _DI, _DS,
                       _ES, _BP: Word); interrupt;
var
  Regs: Registers;
begin
  if Hi(_AX) <> $17 then SavedInt2F
  else
    begin
      with Regs do
      begin
        DI := _AX;
        BX := _BX;
        CX := _CX;
        DX := _DX;
        ES := _ES;
        SI := _SI;
      end;
      DispatchCallRegs(VDD, Regs);
      with Regs do
      begin
        _AX := AX;
        _BX := BX;
        _CX := CX;
        _DX := DX;
        _ES := ES;
        _SI := SI;
      end;
    end;
end;
{$F-}

procedure InstallNTClipboard;
begin
  VDD := RegisterModule(CVDDModule, CVDDInit, CVDDCall);
  if VDD <> 0 then
  begin
    GetIntVec($2F, @SavedInt2F);
    SetIntVec($2F, @Int2FHandler);
  end;
end;

procedure UninstallNTClipboard;
begin
  if VDD <> 0 then
  begin
    SetIntVec($2F, @SavedInt2F);
    UnRegisterModule(VDD);
  end;
end;

{$ENDIF}


{$IFDEF AllowNT}
{$IFDEF AllowVBE2}
procedure ScreenCopy;
var
  Screen: PBitmap;
begin
  if VDD <> 0 then
  begin
    Screen := New(PBitmap, Init);
    if Screen <> nil then
    begin
      Screen^.LoadFromScreen(0, 0, GetMaxX - 1, GetMaxY - 1);
      if not Screen^.Empty then
        Clipboard^.SetBitmap(Screen);
      Screen^.Free;
    end;
  end;
end;
{$ENDIF}
{$ENDIF}


function Clipboard: PClipboard;
begin
  Clipboard := MainClip;
end;

{ TClipboard }

function TClipboard.IsAvailable: Boolean; assembler;
asm
  mov  ax, 1700h
  int  2Fh
  or   ax, ax
  jnz  @@1
  mov  ax, 1
  jmp  @@Exit
@@1:
  {$IFDEF AllowNT}
  call IsWinNT
  or   ax, ax
  jz   @@Exit
  call InstallNTClipboard
  cmp  VDD, 0
  mov  ax, 1
  jnz  @@Exit
  {$ENDIF}
  xor  ax, ax
@@Exit:
end;

constructor TClipboard.Init;
begin
  if not inherited Init then Fail;
  if not IsAvailable then Fail;
end;

function TClipboard.GetVersion: Word; assembler;
asm
  mov  ax, 1700h
  int  2Fh
end;

destructor TClipboard.Done;
var
  Count: Word;
begin
  while FOpenCount > 0 do
  begin
    Count := FOpenCount;
    Close;
    { Pour eviter une boucle infinie }
    if Count = FOpenCount then Break;
  end;
  inherited Done;
end;

procedure TClipboard.Open;
var
  Result: Word;
begin
  if FOpenCount < MaxInt then
  begin
    Inc(FOpenCount);
    if FOpenCount = 1 then
    begin
      asm
        mov  ax, 1701h
        int  2Fh
        mov  Result, ax
      end;
      if Result = 0 then Dec(FOpenCount);
    end;
  end;
end;

procedure TClipboard.Close;
var
  Result: Word;
begin
  if FOpenCount > 0 then
  begin
    Dec(FOpenCount);
    if FOpenCount = 0 then
    begin
      asm
        mov  ax, 1708h
        int  2Fh
        mov  Result, ax
      end;
      if Result = 0 then Inc(FOpenCount);
    end;
  end;
end;

procedure TClipboard.Clear;
var
  Result: Word;
begin
  Open;
  if FOpenCount >= 1 then
  begin
    asm
      mov  ax, 1702h
      int  2Fh
      mov  Result, ax
    end;
    Close;
  end;
end;

procedure TClipboard.SetData(AFormat: Word; var ABuffer; ASize: Longint);
begin
  Open;
  if FOpenCount >= 1 then
  begin
    asm
      mov  ax, 1702h
      int  2Fh
      mov  ax, 1703h
      mov  dx, AFormat
      mov  cx, word ptr ASize
      mov  si, word ptr ASize+2
      les  bx, ABuffer
      int  2Fh
    end;
    Close;
  end;
end;

function TClipboard.GetDataSize(AFormat: Word): Longint;
var
  Result: Longint;
begin
  Result := 0;
  Open;
  if FOpenCount >= 1 then
  begin
    asm
      mov  ax, 1704h
      mov  dx, AFormat
      int  2Fh
      mov  word ptr Result, ax
      mov  word ptr Result+2, dx
    end;
    Close;
  end;
  GetDataSize := Result;
end;

procedure TClipboard.GetData(AFormat: Word; var ABuffer);
begin
  Open;
  if FOpenCount >= 1 then
  begin
    asm
      mov  ax, 1705h
      mov  dx, AFormat
      les  bx, ABuffer
      int  2Fh
    end;
    Close;
  end;
end;

procedure TClipboard.SetLargeData(AFormat: Word; AXMSOfs: Longint; ASize: Longint);
var
  Avail: Boolean;
  Buf: Pointer;
  Blocks, i: Longint;
  Size: Word;
  Result: Word;
begin
{$IFDEF AllowNT}
  Avail := (VDD <> 0);
{$ELSE}
  Avail := False;
{$ENDIF}
  if Avail then
  begin
    GetMem(Buf, CLargeBlockSize);
    if Buf <> nil then
    begin
      Open;
      if FOpenCount >= 1 then
      begin
        { Preparation de l'envoi }
        asm
          mov  ax, 1702h
          int  2Fh
          mov  ax, 1710h
          mov  bx, 0
          mov  es, bx
          mov  si, word ptr ASize+2
          mov  cx, word ptr ASize
          mov  dx, CLargeBlockSize
          int  2Fh
          mov  Result, ax
        end;
        if Result <> 0 then
        begin
          Blocks := ASize div CLargeBlockSize;
          if ASize mod CLargeBlockSize <> 0 then Inc(Blocks);
          for i := 0 to Blocks - 1 do
          begin
            if i < Blocks - 1 then Size := CLargeBlockSize
            else Size := ASize mod CLargeBlockSize;
            FromXms(AXMSOfs + i * CLargeBlockSize, Buf^, Size);
            asm
              mov  ax, 1710h
              mov  dx, AFormat
              les  bx, Buf
              int  2Fh
            end;
          end;
        end;
        Close;
      end;
      FreeMem(Buf, CLargeBlockSize);
    end;
  end
  else
  begin
    if ASize > 65520 then ASize := 65520;
    GetMem(Buf, ASize);
    if Buf <> nil then
    begin
      FromXms(AXMSOfs, Buf^, ASize);
      SetData(AFormat, Buf^, ASize);
      FreeMem(Buf, ASize);
    end;
  end;
end;

procedure TClipboard.GetLargeData(AFormat: Word; AXMSOfs: Longint);
var
  Avail: Boolean;
  Buf: Pointer;
  Size: Longint;
  Blocks, i: Longint;
  Result: Word;
begin
{$IFDEF AllowNT}
  Avail := (VDD <> 0);
{$ELSE}
  Avail := False;
{$ENDIF}
  Size := GetDataSize(AFormat);
  if Avail then
  begin
    GetMem(Buf, CLargeBlockSize);
    if Buf <> nil then
    begin
      Open;
      if FOpenCount >= 1 then
      begin
        asm
          mov  ax, 1711h
          mov  dx, AFormat
          mov  cx, CLargeBlockSize
          mov  bx, 0
          mov  es, bx
          int  2Fh
          mov  word ptr Blocks, cx
          mov  word ptr Blocks+2, si
          mov  Result, ax
        end;
        if Result <> 0 then
        begin
          for i := 0 to Blocks - 1 do
          begin
            if i < Blocks - 1 then Result := CLargeBlockSize
            else Result := Size mod ClargeBlockSize;
            asm
              mov  ax, 1711h
              mov  dx, AFormat
              les  bx, Buf
              int  2Fh
            end;
            ToXms(Buf^, AXMSOfs + i * CLargeBlockSize, Result);
          end;
        FreeMem(Buf, CLargeBlockSize);
        end;
        Close;
      end;
    end;
  end
  else
  begin
    if Size > 65520 then Size := 65520;
    GetMem(Buf, Size);
    if Buf <> nil then
    begin
      GetData(AFormat, Buf^);
      ToXms(Buf^, AXMSOfs, Size);
      FreeMem(Buf, Size);
    end;
  end;
end;

procedure TClipboard.SetAsText(const AText: string);
var
  Buf: array[0..255] of Char;
begin
  Move(AText[1], Buf[0], Length(AText));
  Buf[Length(AText) + 1] := #0;
  SetData(CF_OEMTEXT, Buf, Length(AText) + 1);
end;

function TClipboard.GetAsText: string;
var
  Buf: array[0..255] of Char;
  Result: string;
  Size: Longint;
begin
  Result := '';
  Size := GetDataSize(CF_OEMTEXT);
  if Size <= 256 then
  begin
    GetData(CF_OEMTEXT, Buf);
    Result[0] := Char(Size - 1);
    Move(Buf[0], Result[1], Size - 1);
  end;
  GetAsText := Result;
end;

{$IFDEF AllowVBE2}
procedure TClipboard.SetBitmap(ABmp: PBitmap);
var
  S: PStream;
begin
  if ABmp <> nil then
  begin
    S := ABmp^.SaveToStream;
    if S <> nil then
    begin
      if TypeOf(S^) = TypeOf(TXMSStream) then
      begin
        SetLargeData(CF_DIB, PXMSStream(S)^.GetOfs + SizeOf(TBitmapFileHeader),
                             S^.GetSize - SizeOf(TBitmapFileHeader));
      end;
      S^.Free;
    end;
  end;
end;

procedure TClipboard.GetBitmap(ABmp: PBitmap);
var
  Size: Longint;
  hMem: TXMSOffset;
  S: PXMSStream;
  Header: TBitmapFileHeader;
  BitCount: Word;
begin
  Size := GetDataSize(CF_DIB);
  if (Size > 0) and (ABmp <> nil) then
  begin
    hMem := XGetMem(Size + SizeOf(Header));
    if hMem <> -1 then
    begin
      GetLargeData(CF_DIB, hMem + SizeOf(Header));

      { Le flux possede l'offset hMem : c'est lui qui le libere }
      S := New(PXMSStream, InitFrom(hMem, True));
      if S <> nil then
      begin
        if S^.Status = stOk then
        begin
          FromXms(hMem + SizeOf(Header) + 14, BitCount, SizeOf(BitCount));
          with Header do
          begin
            bfType := $4D42;
            bfSize := Size + SizeOf(Header);
            bfReserved1 := 0;
            bfReserved2 := 0;
            bfOffBits := SizeOf(TBitmapFileHeader) +
                         SizeOf(TBitmapInfoHeader);
            if BitCount < 15 then Inc(bfOffBits, 4 * (1 shl BitCount));
          end;
          ToXms(Header, hMem, SizeOf(Header));

          ABmp^.LoadFromStream(S);
        end;
        S^.Free;
      end;
    end;
  end;
end;
{$ENDIF}


begin
  {$IFDEF AllowNT}
  VDD := 0;
  {$ENDIF}
  SavedExitProc := ExitProc;
  ExitProc := @ClipbrdExitProc;
  MainClip := New(PClipboard, Init);
  if not Assigned(MainClip) then Halt;
end.