{************************************************************}
{                                                            }
{ Library NTDosMgr                                           }
{                                                            }
{ Virtual Dos Device (VDD) destin  l'interfaage entre     }
{ la Machine Virtuelle Dos de Windows NT et l'API 32 bits.   }
{                                                            }
{ Consulter la partie interface de chaque unit pour plus    }
{ d'informations sur les fonctions disponibles.              }
{                                                            }
{ Consulter le Windows Device Driver Kit (DDK) pour plus     }
{ d'informations sur les VDD.                                }
{                                                            }
{ Copyright Eric Sigoillot, 2004 - Tous droits rservs      }
{                                                            }
{************************************************************}
library NTDosMgr;

uses
  Windows, SysUtils, VDD, VDDClipbrd, VDDTimer;

{ Du fait de l'utilisation de Delphi, l'initialisation de la DLL est
  corrompue (Reason prend des valeurs impossibles). VDDInit est donc
  inutile et l'initialisation/finalisation du VDD se fait avec les
  moyens standard de Delphi }
function VDDInit(DllHandle: THandle; Reason: DWord; Reserved: Pointer):
  BOOL; stdcall;
begin
  Result := True;
end;

procedure VDDCall; stdcall;
begin
  { Numero de fonction sur DI }
  if Assigned(VDDCallHook) then
    VDDCallHook(GetDI);
end;


procedure VDDExitProc;
begin
  VDDTimerFinalization;
  VDDClpFinalization;
  VDDFinalization;
end;


exports
  VDDInit name 'VDDInit',
  VDDCall name 'VDDCall';

begin
  if not VDDInitialization or
     not VDDClpInitialization or
     not VDDTimerInitialization then Halt(1);
  AddExitProc(VDDExitProc);
end.

