(****************************************************************************)
(**** Unit NTVDM ************************************************************)
(********************************************************* Version 0.0.2 ****)
(****************************************************************************)
(** (C) Copyright Eric Sigoillot, 2004       (Creation, Maintenance, MAJ)  **)
(**     E-Mail    hdd34@redaction-developpez.com                           **)
(************************************************************** 249 lignes **)
(**                                                                        **)
(**  Caracteristiques :                                                   **)
(**                                                  **)
(**    * Interfacage avec NTVDM.EXE, la console Dos de Windows NT          **)
(**                                                                        **)
(**  Avertissements relatifs a certaines fonctionnalites :                **)
(**               **)
(**    ! Cette unite ne peut etre utilisee que sous environnement NT       **)
(**                                                                        **)
(**  Limitations, problemes connus :                                      **)
(**                                     **)
(**    ! Non compatible avec le mode protege DPMI Borland ou autre         **)
(**                                                                        **)
(**  Configuration minimale necessaire :                                  **)
(**                                 **)
(**    * Processeur 80386 SX avec coprocesseur 80387                       **)
(**    * Windows NT4 ou superieur supportant la technologie NT, tel que    **)
(**      Windows 2000 ou Windows XP                                        **)
(**    * Turbo Pascal 7.0+ ou Borland Pascal 7.0+ (Target... Real)         **)
(**                                                                        **)
(**  Informations de copyright :                                          **)
(**                                         **)
(**    > Cette unite peut etre utilisee librement sans consentement        **)
(**      prealable de l'auteur pour un usage NON COMMERCIAL EXCLUSIVEMENT  **)
(**      La presence du nom de l'auteur dans le logiciel final n'est pas   **)
(**      obligatoire, mais appreciee                                       **)
(**    > En cas de distribution d'un programme (freeware uniquement !)     **)
(**      utilisant cette unite, une copie du logiciel ou bien une adresse  **)
(**      Internet permettant de le recuperer seraient les bienvenues       **)
(**    > L'auteur ne peut EN AUCUN CAS etre tenu responsable d'une         **)
(**      quelconque perte materielle ou logicielle, ou d'un quelconque     **)
(**      prejudice subit par l'utilisateur                                 **)
(**    > Cette unite est toujours en developpement : cela inclut des       **)
(**      risques non negligeables d'erreurs ou d'incompatibilites          **)
(**      Neanmoins, tout est fait pour eviter un quelconque desagrement    **)
(**      Si cette unite se revelait incompatible avec une configuration    **)
(**      quelconque, la responsabilite de l'auteur ne saurait etre engagee **)
(**    > L'utilisation de cette unite se fait AUX RISQUES ET PERILS de     **)
(**      l'utilisateur                                                     **)
(**    > En cas de problemes, il est conseille de les signaler a l'auteur  **)
(**      pour une correction eventuelle en vue d'eviter un desagrement a   **)
(**      un autre utilisateur                                              **)
(**                                                                        **)
(**    > Les retours de la part des utilisateurs de l'unite sont toujours  **)
(**      apprecies. N'hesitez pas a faire part de vos remarques a l'auteur **)
(**                                                                        **)
(**                                                                        **)
(**     D'apres :                                                         **)
(**       * "Microsoft Windows 2000 DDK"                                   **)
(**         Microsoft                                                      **)
(**         Juillet 2000                                                   **)
(**         http://www.microsoft.com/ddk/                                  **)
(**                                                                        **)
(**     Turbo Pascal et Borland Pascal sont des noms deposes de Borland   **)
(**     Windows est un nom depose de Microsoft Corporation                **)
(****************************************************************************)
unit NTVDM;

interface

uses
  Dos;

{ Constantes d'erreur }
const
  ntNoError          = 0;
  ntDLLNotFound      = 1;
  ntDispatchNotFound = 2;
  ntInitNotFound     = 3;
  ntNotEnoughMemory  = 4;
  ntNotWindowsNT     = 255;


function RegisterModule(DLLName, InitProc, DispatchProc: PChar): Word;
procedure UnRegisterModule(hVDD: Word);
procedure DispatchCall(hVDD: Word);
procedure DispatchCallRegs(hVDD: Word; var Regs: Registers);
procedure VDDUnSimulate16;

function NTVDMResult: Word;
function IsWinNT: Boolean;

implementation

const
  ntCallNTVDM        = $C4C4;

const
  ntRegisterModule   = $0058;
  ntUnRegisterModule = $0158;
  ntDispatchCall     = $0258;
  ntUnSimulate16     = $FE;

var
  NTPresent: Boolean;
  NTError: Word;

function NTVDMResult: Word;
begin
  NTVDMResult := NTError;
  if NTError <> ntNotWindowsNT then
    NTError := 0;
end;

function IsWinNT: Boolean; assembler;
const
  NTVDMVer = $3205;
asm
  mov  ax, 3306h
  int  21h
  mov  ax, 1
  mov  NTError, ntNoError
  cmp  bx, NTVDMVer
  je   @@1
  xor  ax, ax
  mov  NTError, ntNotWindowsNT
@@1:
end;


function RegisterModule; assembler;
asm
  push ds
  cmp  NTPresent, 0
  je   @@1
  les  di, InitProc
  lds  bx, DispatchProc
  lds  si, DLLName
  clc
  dw   ntCallNTVDM
  dw   ntRegisterModule
  jnc  @@2
@@1:
  mov  NTError, ax
  xor  ax, ax
@@2:
  pop  ds
end;

procedure UnRegisterModule; assembler;
asm
  cmp  NTPresent, 0
  je   @@1
  mov  ax, hVDD
  dw   ntCallNTVDM
  dw   ntUnRegisterModule
@@1:
end;

procedure DispatchCall; assembler;
asm
  cmp  NTPresent, 0
  je   @@1
  mov  ax, hVDD
  dw   ntCallNTVDM
  dw   ntDispatchCall
@@1:
end;

procedure DispatchCallRegs; assembler;
asm
  cmp  NTPresent, 0
  je   @@1
  push bp
  push ds
  mov  ax,  hVDD
  push ax
  lds  si,  Regs
  cld
  inc  si { On saute AX : ecrase }
  inc  si
  lodsw { BX }
  mov  bx, ax
  lodsw { CX }
  mov  cx, ax
  lodsw { DX }
  mov  dx, ax
  lodsw { BP }
  mov  bp, ax
  lodsw { SI }
  push ax
  lodsw { DI }
  mov  di, ax
  lodsw { DS }
  push ax
  lodsw { ES }
  mov  es, ax
  lodsw { Flags }
  push  ax
  popf
  pop  ds
  pop  si
  pop  ax

  dw   ntCallNTVDM
  dw   ntDispatchCall

  pushf
  push es
  push di
  push bp
  mov  bp, sp
  les  di, [Regs+4+8] { Adresse actuelle de Regs }
  cld
  stosw { AX }
  mov  ax, bx
  stosw { BX }
  mov  ax, cx
  stosw { CX }
  mov  ax, dx
  stosw { DX }
  pop ax
  stosw { BP }
  mov  ax, si
  stosw { SI }
  pop ax
  stosw { DI }
  mov  ax, ds
  stosw { DS }
  pop ax
  stosw { ES }
  pop ax
  stosw { Flags }

  pop ds
  pop bp
@@1:
end;


procedure VDDUnSimulate16; assembler;
asm
  cmp  NTPresent, 0
  je   @@1
  dw  ntCallNTVDM
  db  ntUnSimulate16
@@1:
end;

begin
  NTPresent := IsWinNT;
end.